//
//  ExemploViewController.m
//  SecaoExmplo
//
//  Created by Desenvolvedor on 6/20/13.
//  Copyright (c) 2013 Mobits. All rights reserved.
//

#import "ExemploViewController.h"

enum Indices {
    IndiceUm,
    IndiceDois,
    IndiceTres
};

static BOOL secoesVisiveis[3] = {YES, NO, YES};

@interface ExemploViewController ()

@end

@implementation ExemploViewController

- (id)initWithStyle:(UITableViewStyle)style {
    self = [super initWithStyle:style];
    if (self) {
        self.title = @"Exemplo";
    }
    
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 3;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    if (secoesVisiveis[section])
        switch (section) {
            case IndiceUm:
                return 1;
            case IndiceDois:
                return 2;
            case IndiceTres:
                return 3;
        }
    
    return 0;
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section {
    UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, 20)];
    label.text = [NSString stringWithFormat:@"Seção %d", section+1];
    label.backgroundColor = [UIColor grayColor];
    
    label.tag = section;
    label.userInteractionEnabled = YES;
    
    UITapGestureRecognizer *tapped = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(alternarVisibilidadeSecao:)];
    tapped.numberOfTapsRequired = 1;
    [label addGestureRecognizer:tapped];
    
    return label;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    cell.textLabel.text = [NSString stringWithFormat:@"Célula %d", indexPath.row+1];
    cell.backgroundColor = [UIColor yellowColor];
    
    return cell;
}

#pragma mark -

- (void)alternarVisibilidadeSecao:(UITapGestureRecognizer *)gesture {
    NSInteger section = gesture.view.tag;
    
    if (secoesVisiveis[section]) {
        NSArray *indexPaths = [self indexPathsDaSecao:section];
        secoesVisiveis[section] = false;
        
        [self.tableView deleteRowsAtIndexPaths:indexPaths withRowAnimation:UITableViewRowAnimationBottom];
    }
    else {
        secoesVisiveis[section] = true;
        [self.tableView insertRowsAtIndexPaths:[self indexPathsDaSecao:section] withRowAnimation:UITableViewRowAnimationBottom];
    }
}

- (NSArray *)indexPathsDaSecao:(NSInteger)section {
    NSInteger numberOfRows = [self tableView:self.tableView numberOfRowsInSection:section];
    
    NSMutableArray *indexPaths = [[NSMutableArray alloc] initWithCapacity:numberOfRows];
    for (int i = 0; i < numberOfRows; i++) {
        [indexPaths addObject:[NSIndexPath indexPathForRow:i inSection:section]];
    }
    
    return indexPaths;
}

@end
